import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Base, Type, Point } from "igniteui-react-core";
import { Series } from "./Series";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { LabelCollisionPlacementPositions } from "igniteui-react-core";
import { HighlightedValueLabelMode } from "igniteui-react-core";
import { AutoCalloutVisibilityMode } from "./AutoCalloutVisibilityMode";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CalloutCollisionMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { Size } from "igniteui-react-core";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { DataContext } from "igniteui-react-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { HashPool$2 } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class CalloutLayer extends AnnotationLayer {
    static $t: Type;
    protected bi(): Series;
    protected get_em(): boolean;
    constructor();
    private ac9;
    private adi;
    private ada;
    protected o8(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gd(a: boolean): boolean;
    private aa5;
    private adn;
    private ado;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    acq: string;
    ko(a: any, b: string): any;
    ma(a: string): string;
    get aag(): IFastItemColumn$1<any>;
    set aag(a: IFastItemColumn$1<any>);
    private aab;
    ac4: string;
    get aah(): IFastItemColumn$1<any>;
    set aah(a: IFastItemColumn$1<any>);
    private aac;
    ac7: string;
    get aai(): IFastItemColumn$1<any>;
    set aai(a: IFastItemColumn$1<any>);
    private aad;
    ack: string;
    get aaf(): IFastItemColumn$1<any>;
    set aaf(a: IFastItemColumn$1<any>);
    private aaa;
    aav: boolean;
    acn: string;
    zp: any[];
    acc: string;
    get aae(): IFastItemColumn$1<any>;
    set aae(a: IFastItemColumn$1<any>);
    private z9;
    private aa6;
    private aa9;
    private adc;
    protected cq(): SeriesView;
    qw(a: SeriesView): void;
    protected zz: CalloutLayerView;
    private aba;
    acs: string;
    z6: Series;
    ab9: string;
    private z0;
    get z1(): CalloutPlacementPositionsCollection;
    set z1(a: CalloutPlacementPositionsCollection);
    zo: LabelCollisionPlacementPositions[];
    aau: boolean;
    aaz: boolean;
    aa2: boolean;
    gs(a: Series): boolean;
    aay: boolean;
    aa0: boolean;
    aa1: boolean;
    aa3: boolean;
    z5: HighlightedValueLabelMode;
    get zu(): AutoCalloutVisibilityMode;
    set zu(a: AutoCalloutVisibilityMode);
    get zt(): AutoCalloutVisibilityMode;
    set zt(a: AutoCalloutVisibilityMode);
    static readonly ad5: DependencyProperty;
    abd: number;
    aax: boolean;
    aaw: boolean;
    abm: number;
    aex: Brush;
    aev: Brush;
    aet: Brush;
    aes: Brush;
    abn: number;
    aew: Brush;
    aeu: Brush;
    get ae1(): Thickness;
    abf: number;
    abh: number;
    abg: number;
    abe: number;
    zw: CalloutCollisionMode;
    abi: number;
    abj: number;
    acv: string;
    private z7;
    get z8(): FontInfo;
    protected yg(a: Series, b: boolean): void;
    protected yi(a: Frame, b: SeriesView): void;
    private aa7;
    private aa4;
    private aaj;
    private aez;
    protected sk(a: Rect, b: Rect): void;
    protected sj(a: Rect, b: Rect): void;
    private aaq;
    private abl;
    private aey;
    get ae0(): Rect;
    set ae0(a: Rect);
    private aao;
    private adj;
    private ade;
    private aak;
    private abo;
    private abp;
    private aal;
    private adb;
    private aam;
    private abk;
    private abb;
    private abq;
    protected w9(a: Series): boolean;
    qk(): void;
    private aap;
    adh(): void;
    calloutContentUpdating: (sender: any, args: CalloutContentUpdatingEventArgs) => void;
    calloutLabelUpdating: (sender: any, args: CalloutLabelUpdatingEventArgs) => void;
    calloutSeriesSelecting: (sender: any, args: CalloutSeriesSelectingEventArgs) => void;
    private aa8;
    private adk;
    private aas;
    private aat;
    private abc;
    private aar;
    protected b0(): SeriesHitTestMode;
    a1(a: Point, b: boolean): DataContext;
    gu(a: Point, b: boolean): boolean;
    protected adm(a: CalloutLayerFrame, b: boolean): void;
    protected yl(a: Frame, b: SeriesView): void;
    protected f8(): boolean;
    private zr;
    protected q4(a: any, b: string, c: any, d: any): void;
    private zv;
    private zq;
    private adl;
    private aan;
    private zs;
    private adf;
    private add;
    private adg;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CalloutLayer);
    protected b7: CalloutLayer;
    private cc;
    au(): void;
    private b9;
    private cf;
    private ch;
    private cg;
    cb: HashPool$2<CalloutAnnotationWrapper, CalloutView>;
    cq(a: Brush): Brush;
    protected a8(a: RenderingContext, b: boolean): void;
    protected ca(): FontInfo;
    an(a: any): void;
    private cd;
    cs(a: TextBlock): Size;
    private ce;
    private b8;
    cr(a: any, b: Thickness): Size;
    cj(a: CalloutView, b: number, c: number): void;
    ck(a: CalloutView, b: CalloutAnnotationWrapper, c: any): void;
    cl(a: Series, b: Brush): Brush;
    co(): Brush;
    cm(): Brush;
    cp(a: Series, b: Brush): Brush;
    cn(a: Series, b: Brush): Brush;
    ci(): void;
}
/**
 * @hidden
 */
export declare class CalloutView extends Base {
    static $t: Type;
    constructor(a: CalloutLayerView);
    private a;
    y: Visibility;
    j(a: RenderingContext): void;
    private l;
    private t;
    private q;
    private s;
    get r(): Point;
    set r(a: Point);
    get p(): Brush;
    set p(a: Brush);
    get o(): Brush;
    set o(a: Brush);
    get n(): Brush;
    set n(a: Brush);
    get m(): Brush;
    set m(a: Brush);
    get e(): number;
    set e(a: number);
    private w;
    private v;
    get x(): Thickness;
    set x(a: Thickness);
    private c;
    get d(): number;
    set d(a: number);
    get h(): any;
    set h(a: any);
    f: number;
    g: number;
    u(): Size;
    private b;
    k(a: Series, b: CalloutAnnotationWrapper, c: any): void;
    i(a: CalloutLayer, b: FontInfo, c: any): void;
}
